diff --git a/contrib/amd/scripts/automount2amd.in b/contrib/amd/scripts/automount2amd.in
index e99c74b..79a7b77 100755
--- a/contrib/amd/scripts/automount2amd.in
+++ b/contrib/amd/scripts/automount2amd.in
@@ -2,7 +2,7 @@
 #
 # Convert Sun automount map format to amd format
 #
-# Package:      am-utils-6.0
+# Package:      am-utils-6.x
 # Author:       Mike Walker <mike@tab00.larc.nasa.gov>
 #		Erez Zadok <ezk@cs.columbia.edu>
 #
@@ -26,7 +26,7 @@
 #
 # You should set the DOMAIN and DEFAULT variables to your preferences.
 #
-# $Id: automount2amd.in,v 1.1 1999/08/16 01:16:36 ezk Exp $
+# $Id: automount2amd.in,v 1.2 2002/01/15 18:25:25 ezk Exp $
 #
 
 require "ctime.pl";
diff --git a/contrib/amd/scripts/ctl-amd.in b/contrib/amd/scripts/ctl-amd.in
index 22c3677..694b31a 100755
--- a/contrib/amd/scripts/ctl-amd.in
+++ b/contrib/amd/scripts/ctl-amd.in
@@ -1,8 +1,8 @@
 #!/bin/sh
 # control starting, stopping, or restarting amd.
-# usage: ctl-amd [start | stop | restart]
+# usage: ctl-amd [start|stop|status|restart|condrestart|reload]
 #
-# Package:	am-utils-6.0
+# Package:	am-utils-6.x
 # Author:	Erez Zadok <ezk@cs.columbia.edu>
 #
 # chkconfig: - 72 28
@@ -60,16 +60,20 @@ fi
 return 1
 }
 
+# before running any real programs, chdir to / to avoid possible hangs on
+# (NFS) mounts which may be restarting.
+cd /
+
 # search for amd.conf file
-CF_FILE="${prefix}/etc/amd.conf"
+CF_FILE="@sysconfdir@/amd.conf"
 # any local copy of the conf file overrides the "global" one
 if [ -f /etc/amd.conf ]
 then
 	CF_FILE="/etc/amd.conf"
 fi
-if [ -f ${prefix}/etc/amd.conf ]
+if [ -f @sysconfdir@/amd.conf ]
 then
-	CF_FILE="${prefix}/etc/amd.conf"
+	CF_FILE="@sysconfdir@/amd.conf"
 fi
 if [ -f /etc/local/amd.conf ]
 then
@@ -85,13 +89,12 @@ fi
 
 case "$1" in
 'start')
-	#
 	# Start the amd automounter.
-	#
 	if [ -x @sbindir@/amd ]
 	then
 		# do not specify full path of amd so killproc() works
 		amd -F $CF_FILE $CF_TAG
+		test -x /var/lock/subsys && touch /var/lock/subsys/amd
 	fi
 	;;
 
@@ -100,6 +103,7 @@ case "$1" in
 	echo "killing amd..."
 	killproc " amd"
 	wait4amd2die
+	rm -f /var/lock/subsys/amd
 	;;
 
 'restart')
@@ -115,7 +119,37 @@ case "$1" in
 	fi
 	;;
 
+'condrestart')
+     if [ -f /var/lock/subsys/amd ]; then
+            ctl-amd stop
+            ctl-amd start
+        fi
+     ;;
+
+'reload')
+        amq -f
+        ;;
+
+'status')
+	# run amq -v to produce status
+	pid=`amq -p 2>/dev/null`
+	if [ $? = 0 ]
+	then
+		echo "amd (pid $pid) is running..."
+	else
+		echo "amd is stopped"
+	fi
+	;;
+
+# start_msg and stop_msg are for HPUX
+'start_msg')
+	echo "Start am-utils 6.1 automounter"
+	;;
+'stop_msg')
+	echo "Stop am-utils 6.1 automounter"
+	;;
+
 *)
-	echo "Usage: @sbindir@/ctl-amd [ start | stop | restart ]"
+	echo "Usage: $0 [start|stop|status|restart|condrestart|reload]"
 	;;
 esac
diff --git a/contrib/amd/scripts/ctl-hlfsd.in b/contrib/amd/scripts/ctl-hlfsd.in
index ebb12b8..ee0dd27 100755
--- a/contrib/amd/scripts/ctl-hlfsd.in
+++ b/contrib/amd/scripts/ctl-hlfsd.in
@@ -2,7 +2,7 @@
 # control starting, stopping, or restarting hlfsd.
 # usage: ctl-hlfsd [start | stop | restart]
 #
-# Package:	am-utils-6.0
+# Package:	am-utils-6.x
 # Author:	Erez Zadok <ezk@cs.columbia.edu>
 #
 # chkconfig: - 72 28
@@ -51,6 +51,10 @@ fi
 return 1
 }
 
+# before running any real programs, chdir to / to avoid possible hangs on (NFS)
+# mounts.
+cd /
+
 # locate logs directory
 if [ -d /var/log ]; then
 	logdir="/var/log"
@@ -62,14 +66,17 @@ fi
 if [ -d /var/mail/. ]; then
 	maildir="/var/mail"
 	altmaildir="/var/alt_mail"
+elif [ -d /var/spool/mail/. ]; then
+	maildir="/var/spool/mail"
+	altmaildir="/var/spool/alt_mail"
 else
 	maildir="/usr/spool/mail"
 	altmaildir="/usr/spool/alt_mail"
 fi
 
 # locate any optional password file
-if [ -f ${prefix}/etc/passwd ]; then
-	PASSWD_FILE="-P ${prefix}/etc/passwd"
+if [ -f @sysconfdir@/passwd ]; then
+	PASSWD_FILE="-P @sysconfdir@/passwd"
 else
 	PASSWD_FILE=""
 fi
@@ -81,14 +88,16 @@ case "$1" in
 	#
 	if [ -x @sbindir@/hlfsd -a -h $maildir ]
 	then
-		echo @sbindir@/hlfsd ${PASSWD_FILE} -a $altmaildir -x all -D fork -l $logdir/hlfsd /mail/home .mailspool
-		@sbindir@/hlfsd ${PASSWD_FILE} -a $altmaildir -x all -D fork -l $logdir/hlfsd /mail/home .mailspool &
+		echo @sbindir@/hlfsd ${PASSWD_FILE} -a $altmaildir -x all -l $logdir/hlfsd /mail/home .mailspool
+		@sbindir@/hlfsd ${PASSWD_FILE} -a $altmaildir -x all -l $logdir/hlfsd /mail/home .mailspool &
+		test -x /var/lock/subsys && touch /var/lock/subsys/hlfsd
 	fi
 	;;
 
 'stop')
 	# prepend space to program name to ensure only amd process dies
 	killproc " hlfsd"
+	test -f /var/lock/subsys/hlfsd && rm -f /var/lock/subsys/hlfsd
 	;;
 
 'restart')
diff --git a/contrib/amd/scripts/expn.in b/contrib/amd/scripts/expn.in
index de48f8d..9ae5757 100755
--- a/contrib/amd/scripts/expn.in
+++ b/contrib/amd/scripts/expn.in
@@ -15,7 +15,7 @@ $SOCK_STREAM = &SOCK_STREAM;
 # system requirements:
 # 	must have 'nslookup' and 'hostname' programs.
 
-# $Header: /src/cvsroot/am-utils-6.0/scripts/expn.in,v 1.2 1999/09/18 08:38:07 ezk Exp $
+# $Header: /home/cvsroot/am-utils/scripts/expn.in,v 1.5 2002/07/11 14:28:20 ezk Exp $
 
 # TODO:
 #	less magic should apply to command-line addresses
@@ -59,7 +59,7 @@ $SOCK_STREAM = &SOCK_STREAM;
 #  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 #  SUCH DAMAGE.
 #
-# This copyright notice derrived from material copyrighted by the Regents
+# This copyright notice derived from material copyrighted by the Regents
 # of the University of California.
 #
 # Contributions accepted.
@@ -114,7 +114,7 @@ $0 = "$av0 - lookup host FQDN and IP addr";
 ($hostname,$aliases,$type,$len,$thisaddr) = gethostbyname($name);
 
 $0 = "$av0 - parsing args";
-$usage = "Usage: $av0 [-1avwd] user[\@host] [user2[host2] ...]";
+$usage = "Usage: $av0 [-1avwd] user[\@host] [user2[\@host2] ...]";
 for $a (@ARGV) {
 	die $usage if $a eq "-";
 	while ($a =~ s/^(-.*)([1avwd])/$1/) {
@@ -257,7 +257,7 @@ while (@hosts) {
 			# on the results of our query until we have looked
 			# at the complete output.  @toFinal stores expansions
 			# that will be final if we take them.  @toExpn stores
-			# expnansions that are not final.  @isValid keeps
+			# expansions that are not final.  @isValid keeps
 			# track of our ability to send mail to each of the
 			# expansions.
 			#
@@ -783,7 +783,7 @@ sub domainify
 	}
 
 	#
-	# There are several weird situtations that need to be
+	# There are several weird situations that need to be
 	# accounted for.  They have to do with domain relay hosts.
 	#
 	# Examples:
@@ -954,7 +954,7 @@ sub mxredirect
 	return undef;
 }
 # follow mx records, return a hostname
-# also follow temporary redirections comming from &domainify and
+# also follow temporary redirections coming from &domainify and
 # &mxlookup
 sub mx
 {
@@ -1032,7 +1032,7 @@ sub mxlookup
 		}
 		if (/Non-existent domain/) {
 			#
-			# These addresss are hosed.  Kaput!  Dead!
+			# These addresses are hosed.  Kaput!  Dead!
 			# However, if we created the address in the
 			# first place then there is a chance of
 			# salvation.
@@ -1091,7 +1091,7 @@ sub mxunroll
 	print "looking for mxbacktrace{$addr *** $host}\n"
 		if ($debug > 1);
 	while (defined $mxbacktrace{"$addr *** $host"}) {
-		print "Unrolling MX expnasion: \@$host:$addr -> "
+		print "Unrolling MX expansion: \@$host:$addr -> "
 			if ($debug || $verbose);
 		$host = $mxbacktrace{"$addr *** $host"};
 		print "\@$host:$addr\n"
@@ -1103,7 +1103,7 @@ sub mxunroll
 		if ($host =~ /\./);
 	return 0;
 }
-# register a completed expnasion.  Make the final address as
+# register a completed expansion.  Make the final address as
 # simple as possible.
 sub final
 {
@@ -1315,7 +1315,7 @@ Finally, the
 debug, flag will expose many of the inner workings so that
 it is possible to eliminate bugs.
 .SH ENVIRONMENT
-No enviroment variables are used.
+No environment variables are used.
 .SH FILES
 .PD 0
 .B /tmp/expn$$
diff --git a/contrib/amd/scripts/fix-amd-map.in b/contrib/amd/scripts/fix-amd-map.in
index 6746462..9bbc9b6 100755
--- a/contrib/amd/scripts/fix-amd-map.in
+++ b/contrib/amd/scripts/fix-amd-map.in
@@ -5,7 +5,7 @@
 # takes any number of files on the command line, and produces
 # a fixed map on stdout.
 #
-# Package:	am-utils-6.0
+# Package:	am-utils-6.x
 # Author:	Erez Zadok <ezk@cs.columbia.edu>
 #
 
diff --git a/contrib/amd/scripts/fixrmtab.in b/contrib/amd/scripts/fixrmtab.in
index 33b7bcf..2300380 100755
--- a/contrib/amd/scripts/fixrmtab.in
+++ b/contrib/amd/scripts/fixrmtab.in
@@ -5,7 +5,7 @@
 #
 # usage: fixrmtab host1 host2 ...
 #
-# Package:	am-utils-6.0
+# Package:	am-utils-6.x
 # Author:	Andreas Stolcke <stolcke@icsi.berkeley.edu>
 
 #set -x
diff --git a/contrib/amd/scripts/redhat-ctl-amd.in b/contrib/amd/scripts/redhat-ctl-amd.in
new file mode 100755
index 0000000..4d00d47
--- /dev/null
+++ b/contrib/amd/scripts/redhat-ctl-amd.in
@@ -0,0 +1,106 @@
+#!/bin/bash
+#
+# Version: 1.3
+#
+# chkconfig: - 72 28
+# description: Runs the automount daemon that mounts devices and NFS hosts \
+#	       on demand.
+# processname: amd
+# config: /etc/amd.conf
+#
+
+# we require the /etc/amd.conf file
+[ -f /etc/amd.conf ] || exit 0
+[ -f /etc/sysconfig/amd ] || exit 0
+
+# Source function library.
+. /etc/init.d/functions
+
+# Recover AMDOPTS from /etc/sysconfig/amd.
+if [ -f /etc/sysconfig/amd ] ; then
+	. /etc/sysconfig/amd
+fi
+
+RETVAL=0
+prog=amd
+prefix=@prefix@
+exec_prefix=@exec_prefix@
+amd=@sbindir@/amd
+
+start() {
+	echo -n "Starting $prog: "
+	daemon $amd -F /etc/amd.conf $AMDOPTS $OPTIONS $MOUNTPTS
+	RETVAL=$?
+	echo
+	[ $RETVAL = 0 ] && touch /var/lock/subsys/amd
+	return $RETVAL
+}
+
+stop() {
+
+	echo -n "Stopping $prog: "
+        # modeled from /usr/sbin/ctl-amd
+	pid=`/usr/sbin/amq -p 2>/dev/null`
+	if [ "$pid" = "" ] ; then
+		# amq -p did not give pid, so try ps
+		pid=`ps acx 2>/dev/null | grep "amd" | sed -e 's/^  *//' -e 's/ .*//'`
+	fi
+	if [ "$pid" = "" ] ; then
+		failure "amd shutdown pid"
+		echo
+		return 1
+	fi
+	kill $pid
+        # and this part is from wait4amd2die
+	delay=5
+	count=6
+	i=1
+	maxcount=`expr $count + 1`
+	while [ $i != $maxcount ]; do
+		# run amq
+		/usr/sbin/amq > /dev/null 2>&1
+		if [ $? != 0 ]
+		then
+			# amq failed to run (because amd is dead)
+			success "amd shutdown"
+			rm -f /var/lock/subsys/amd
+			echo
+			return 0
+		fi
+		sleep $delay
+		i=`expr $i + 1`
+	done
+	failure "amd shutdown (still up)"
+	echo
+	return 1
+}
+# See how we were called.
+case "$1" in
+  start)
+        start
+	;;
+  stop)
+        stop
+	;;
+  status)
+	status $amd
+	;;
+  restart)
+	stop
+	start
+	;;
+  condrestart)
+        if [ -f /var/lock/subsys/amd ]; then
+	    stop
+	    start
+	fi
+	;;
+  reload)
+	action "Reloading $prog:" killall -HUP $amd
+	;;
+  *)
+ 	echo "Usage: $0 {start|stop|restart|reload|condrestart|status}"
+	exit 1
+esac
+
+exit 0
diff --git a/contrib/amd/scripts/test-attrcache.in b/contrib/amd/scripts/test-attrcache.in
new file mode 100755
index 0000000..061308b
--- /dev/null
+++ b/contrib/amd/scripts/test-attrcache.in
@@ -0,0 +1,135 @@
+#!/bin/sh
+# Script to test the attribute cache behavior of the local OS client.
+# If this script fails, it means that Amd cannot turn off the attrcache
+# reliably on this host, and Amd therefore may not run reliably.  See
+# the README.attrcache file distributed with this am-utils.
+#	-Erez Zadok, September 29, 2005
+
+# set PATH (must install am-utils first)
+prefix=@prefix@
+exec_prefix=@exec_prefix@
+PATH=@sbindir@:@bindir@:/usr/ucb:/usr/bin:/bin:${PATH}
+export PATH
+
+# test if amd is running
+amq -p > /dev/null 2>&1
+if test $? = 0
+then
+	echo "### Amd already running... please shutdown Amd first"
+	exit 1
+fi
+
+mapfile="/tmp/amd.testmap.$$"
+logfile="/var/log/amd"
+delay=1
+a=/a
+
+CreateMap1 () {
+	echo "### Creating correct map"
+	cat - >$mapfile <<EOF
+a	type:=link;fs:=/tmp/a
+EOF
+}
+
+CreateMap2 () {
+	echo "### Creating weird map"
+	cat - >$mapfile <<EOF
+a	type:=link;fs:=/tmp/b
+EOF
+}
+
+StopAMD () {
+	ctl-amd stop
+# do not delete files we may need to use to debug Amd
+#	rm -f /tmp/a /tmp/b $mapfile $logfile
+}
+
+touch /tmp/a
+touch /tmp/b
+
+CreateMap1
+echo amd -x all -D all -r -l $logfile $a $mapfile -cache:=mapdefault,sync
+amd -x all -D all -r -l $logfile $a $mapfile -cache:=mapdefault,sync
+sleep 3				# give amd chance to start properly
+amq
+inode_a=`ls -lLi /tmp/a | awk '{print $1}'`
+inode_b=`ls -lLi /tmp/b | awk '{print $1}'`
+ls -lLi $a/a
+ls -lLi $a/b
+ls -l $mapfile
+
+# how many times to try until we call it a success...
+maxtry=10
+while test $maxtry -gt 0
+do
+	echo "$maxtry tries left ..."
+	let maxtry=maxtry-1
+	amq
+	CreateMap1
+	sleep $delay
+
+	ls -l $mapfile
+	echo "### looking at a... should get a"
+	ino=`ls -lLi $a/a | awk '{print $1}'`
+	if test -z "$ino"
+	then
+		ls -li $a/a
+		amq
+		amq -m
+		stat $a
+		echo "a link does not exist!"
+		StopAMD
+		exit 1
+	fi
+	if test $ino -ne $inode_a
+	then
+		ls -li $a/a
+		amq
+		amq -m
+		stat $a
+		echo "a link does not point to A!"
+		StopAMD
+		exit 1
+	fi
+
+# Here is the main trick we try: force amd to flush one entry, then
+# change the amd map on disk, and then see if the kernel will have
+# flushed the attribute cache; if it did, then Amd will see the
+# correctly changed map entry.
+
+	amq -u $a/a
+	sleep $delay
+	stat $a
+
+	CreateMap2
+	sleep $delay
+
+	ls -l $mapfile
+	echo "### looking at a... should get b"
+	ino=`ls -lLi $a/a | awk '{print $1}'`
+	if test -z "$ino"
+	then
+		ls -li $a/a
+		amq
+		amq -m
+		stat $a
+		echo "a link does not exist!"
+		StopAMD
+		exit 1
+	fi
+	if test $ino -ne $inode_b
+	then
+		ls -li $a/a
+		amq
+		amq -m
+		stat $a
+		echo "a link does not point to B!"
+		StopAMD
+		exit 1
+	fi
+
+	amq -u $a/a
+	sleep $delay
+	stat $a
+done
+StopAMD
diff --git a/contrib/amd/scripts/wait4amd.in b/contrib/amd/scripts/wait4amd.in
index 5fd5030..5e6c33a 100755
--- a/contrib/amd/scripts/wait4amd.in
+++ b/contrib/amd/scripts/wait4amd.in
@@ -3,7 +3,7 @@
 # usage: wait4amd <hostname> [<command> [args ...]]
 # If only hostname is supplied, command defaults to rsh $hostname
 #
-# Package:	am-utils-6.0
+# Package:	am-utils-6.x
 # Author:	Erez Zadok <ezk@cs.columbia.edu>
 
 #set -x
diff --git a/contrib/amd/scripts/wait4amd2die.in b/contrib/amd/scripts/wait4amd2die.in
index d3541e7..94a0851 100755
--- a/contrib/amd/scripts/wait4amd2die.in
+++ b/contrib/amd/scripts/wait4amd2die.in
@@ -4,7 +4,7 @@
 # If not specified, delay=5 seconds and count=6 (total 30 seconds)
 # If at end of total delay amd is till up, return 1; else return 0.
 #
-# Package:	am-utils-6.0
+# Package:	am-utils-6.x
 # Author:	Erez Zadok <ezk@cs.columbia.edu>
 
 #set -x
@@ -20,14 +20,14 @@ if test -n "$1"
 then
 	delay=$1
 else
-	delay=5
+	delay=3
 fi
 # how many times to delay
 if test -n "$2"
 then
 	count=$2
 else
-	count=6
+	count=10
 fi
 
 i=1
diff --git a/contrib/amd/tasks b/contrib/amd/tasks
index 976d3b2..24b6834 100644
--- a/contrib/amd/tasks
+++ b/contrib/amd/tasks
@@ -1,65 +1,37 @@
-# -*- text -*-
-
-			  AM-UTILS-6.0 TASKS TODO
+			  AM-UTILS-6.1 TASKS TODO
 
 Please volunteer to do any of the following:
 
-- complete testing of untested platforms in INSTALL file
-	ncr2
-	sunos 3.5
-
 - autofs support: see README.autofs for details.
-	needs to be re-ported to solaris 2.6 (headers changed)
 
 - deal with everything that has XXX on it in the sources
 - documentation update ("XXX: FILL IN" sections).
 
-- hlfsd should be able to not use /var/alt_mail, but send code 75 back to
-  sendmail (telling it to re-queue the mail and retry later).
-
 - compatibility with Sun's automount maps?
 	should be easier via the amd.conf file to specify type of map
-	perhaps done at the same time autofs support is done.
-
-- a selector ala if_exists() for networkmask(1.2.3.4/5.6.7.8), will match
-  against all known IP addresses of this host.
 
 - convert to using my own rpcgen .x files for amq/amq/nfs (v2 and v3)
 
-- support multiple "fail-over" NFS mounts in Solaris 2.6.
-
-- use packaging info for various OSs (such as RPM, Redhat Package Format)
+- use packaging info for various OSs (such as RPM, Redhat Package Manager)
 
 - $mindelay and $maxdelay in milliseconds
 
 - multiple nfsl should be matched if one matched and nfs mount failed.  fall
   through.
-- fall through syntax?  opts:=nofail,fallthrough?
+- support multiple "fail-over read-only" NFS mounts in Solaris 2.6+.
 
 - random nfs rhost:={srv1, srv2, srv3}
 
 - nfslx, same as nfsl, but using linkx
 
-- find out why this sometimes works and sometimes not:
-	mcl	-rhost:=minetta host!=${rhost};type:=nfs host==${rhost}
-
 - loadable info_*, amfs_*, and ops_* modules (lazy evaluation).
 
-- hlfsd for ~root/.mailspool (getpwnam("root"))
 - hlfsd should daemonize even if -DDEBUG, then use -D nofork
 
 - fixmount should use generic code from transp/transp_{tli,sockets}.c
 
-- report netbsd/openbsd bugs in BUGS file
-
 - reverse notion of -F and other cmd-line options, so they override the
-amd.conf file (right now amd.conf overrides cmd-line options).
-
-- y2k compliance.
-
-- an un/install script for binaries
-
-- update README
+  amd.conf file (right now amd.conf overrides cmd-line options).
 
 - add am-utils URL and COPYRIGHT to all distributed scripts and sources and
   programs etc. also to amq -v output.
@@ -67,38 +39,73 @@ amd.conf file (right now amd.conf overrides cmd-line options).
 - ion: browsable_dirs only works for nis if in [global] broken if it is file
   maps.
 
-- all if statements should have an else clause because of Ultrix's /bin/sh.
-
-- look for obsolete AM_* macros and use newer AC_* ones
-- use 3rd arg to AC_CHECK_TYPE (headers)
-
-- FreeBSD 3.1 doesn't have SYMTTL flag, so the mtime of the hlfsd symlink is
-  always new.  This breaks hlfsd on FreeBSD 3.1, b/c the acregmin/max code
-  depends on the time that the symlink was created.  Solution: best is to
-  support NOAC in the FreeBSD kernel, otherwise hlfsd will have to know not
-  to turn on this code in hlfsd/stubs.c:
-
-    if (++slinkfattr.na_mtime.nt_useconds == 0)
-      ++slinkfattr.na_mtime.nt_seconds;
-
-- support nqnfs as per Jeffrey C Honig <jch@BSDI.COM>: "Besides having
-  NFSMNT_NQNFS set when you try to do the mount, NQNFS requires that you do
-  the nfssvc() call to create an nqnfs client daemon.  I can't see any
-  obvious way to check if the server supports NQNFS."
-
 - browsable 'auto' style maps.
 
-- amq man page: amq -f also reloads maps that are not updated
-
 - mention signals in amd man page
 
 - ALLOWED_MOUNT_TIME of 40 seconds is way too long!
-- need option to turn off pings of portmapper before trying a mount
+- detecting down'ed hosts faster: use default portmap TTL variables?
+- push get_nfs_version() down into a child process
 
-- type:=program should not require umount command. can use defult
+- type:=program should not require umount command. can use default
   umount(). it works for smbmount/umount.
 
 - document var[0-7] variables/selectors
 
 - need a way to export a nfs-mount point after it is being mounted (jukebox
   mounts).  can do this with type:=program.
+
+- support port=n, for machines that use NFS on a different port
+
+- nfsl may be buggy when fs:= is specified explicitly (lockup?)
+
+- y2k: amq /home (mounted time uses YY instead of YYYY)
+
+- new amd.conf option to disable amq listener altogether (security)
+	Should be available even if DEBUG is off.
+
+- new amd.conf option dynamic_system_params to recompute osver, karch,
+  etc. from uname() dynamically.
+
+- solaris 8 doesn't pick up hsfs/pcfs/etc *_args structures and mount flags
+
+- avoid having to compile ops_nfs3.o
+
+- linux support for ext3
+
+- be able to pass generic mount options to systems w/ a mount(2) that
+  supports it (Linux).  Perhaps genopt="foo,bar" syntax.
+
+- support several different nfs servers inside one nfsx entry
+
+- reimplement the "parallel mounting" for multiple matching sub-entries
+
+- fix amd.conf parser so it can parse key=value without spaces around the
+  "=" sign.  Note this isn't so trivial because 'value' may include "="
+  signs.
+
+- NFSv4 support (such a short "tasks" entry given how much work it is :-)
+
+
+* documentation
+- document what can and what can't be a top-level mount type (i.e. a
+  map-backed or map-holding type). Currently that's toplvl, auto, and
+  direct.
+- document how to add a direct map to amd.conf.
+
+* autofs stuff
+Linux:
+- host mounts broken with autofs v3
+- nfsx status unknown
+- local filesystems (ufs, etc) status unknown
+
+Solaris:
+- host mounts status unknown
+- nfsx status unknown
+- local filesystems (ufs, etc) status unknown
+
+FreeBSD:
+- just do it
+
+All:
+- mntfs->mf_fo->opt_fs can contain garbage sometimes??
diff --git a/contrib/amd/vers.m4 b/contrib/amd/vers.m4
new file mode 100644
index 0000000..7343910
--- /dev/null
+++ b/contrib/amd/vers.m4
@@ -0,0 +1 @@
+[6.1.5]dnl
diff --git a/contrib/amd/wire-test/wire-test.c b/contrib/amd/wire-test/wire-test.c
index 1cbf921..bcaaf5a 100644
--- a/contrib/amd/wire-test/wire-test.c
+++ b/contrib/amd/wire-test/wire-test.c
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1997-1999 Erez Zadok
+ * Copyright (c) 1997-2006 Erez Zadok
  * Copyright (c) 1990 Jan-Simon Pendry
  * Copyright (c) 1990 Imperial College of Science, Technology & Medicine
  * Copyright (c) 1990 The Regents of the University of California.
@@ -36,11 +36,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- *      %W% (Berkeley) %G%
  *
- * $Id: wire-test.c,v 1.4 1999/02/04 07:24:54 ezk Exp $
- * $FreeBSD: src/contrib/amd/wire-test/wire-test.c,v 1.5 1999/09/15 05:45:17 obrien Exp $
- * $DragonFly: src/contrib/amd/wire-test/wire-test.c,v 1.2 2003/06/17 04:23:58 dillon Exp $
+ * File: am-utils/wire-test/wire-test.c
  *
  */
 
@@ -81,7 +78,7 @@ main(int argc, char **argv)
   }
 
   /* also print my IP address */
-  amu_get_myaddress(&myipaddr);
+  amu_get_myaddress(&myipaddr, NULL);
   fprintf(stderr, "My IP address is 0x%x.\n", (unsigned int) htonl(myipaddr.s_addr));
 
   /*
@@ -100,6 +97,7 @@ main(int argc, char **argv)
   }
   ip = (struct sockaddr_in *) xmalloc(sizeof(struct sockaddr_in));
   memset((voidp) ip, 0, sizeof(*ip));
+  /* as per POSIX, sin_len need not be set (used internally by kernel) */
   ip->sin_family = AF_INET;
   memmove((voidp) &ip->sin_addr, (voidp) hp->h_addr, sizeof(ip->sin_addr));
   ip->sin_port = htons(NFS_PORT);
diff --git a/etc/rc.d/amd b/etc/rc.d/amd
index 2ba0019..1825bd0 100644
--- a/etc/rc.d/amd
+++ b/etc/rc.d/amd
@@ -1,51 +1,47 @@
 #!/bin/sh
 #
-# $NetBSD: amd,v 1.10 2002/04/29 12:08:17 lukem Exp $
-# $FreeBSD: src/etc/rc.d/amd,v 1.9 2002/10/12 10:31:31 schweikh Exp $
-# $DragonFly: src/etc/rc.d/amd,v 1.5 2005/11/19 21:47:32 swildner Exp $
+# $FreeBSD: src/etc/rc.d/amd,v 1.27 2012/11/17 01:49:04 svnexp Exp $
 #
 
 # PROVIDE: amd
-# REQUIRE: rpcbind mountcritremote ypbind nfsclient
+# REQUIRE: rpcbind ypset nfsclient mountcritremote ldconfig
 # BEFORE: DAEMON
+# KEYWORD: nojail shutdown
 
 . /etc/rc.subr
 
 name="amd"
-rcvar=`set_rcvar`
+rcvar="amd_enable"
 command="/usr/sbin/${name}"
-
-	start_precmd="amd_precmd"
-	command_args="&"
+start_precmd="amd_precmd"
+command_args="&"
+extra_commands="reload"
 
 amd_precmd()
 {
-		if ! checkyesno nfs_client_enable; then
-			force_depend nfsclient || return 1
-		fi
-
-		if ! checkyesno rpcbind_enable  && \
-			! /etc/rc.d/rpcbind forcestatus 1>/dev/null 2>&1
-			then
-				force_depend rpcbind || return 1
+	force_depend nfsclient nfs_client || return 1
+	force_depend rpcbind || return 1
+
+	case ${amd_map_program} in
+	[Nn][Oo] | '')
+		;;
+	*)
+		rc_flags="${rc_flags} `echo $(eval ${amd_map_program})`"
+		;;
+	esac
+
+	case "${amd_flags}" in
+	'')
+		if [ ! -r /etc/amd.conf ]; then
+			warn 'amd will not load without arguments'
+			return 1
 		fi
-
-		case ${amd_map_program} in
-			[Nn][Oo] | '')
-			;;
-		*)
-			rc_flags="${rc_flags} `eval ${amd_map_program}`"
-			;;
-		esac
-
-		case "${amd_flags}" in
-			'')
-			if [ ! -r /etc/amd.conf ]; then
-				warn 'amd will not load without arguments'
-				return 1
-			fi
-			;;
-		esac
+		;;
+	*)
+		rc_flags="-p ${rc_flags}"
+		command_args="> /var/run/amd.pid 2> /dev/null"
+		;;
+	esac
 }
 
 load_rc_config $name
diff --git a/usr.sbin/amd/Makefile b/usr.sbin/amd/Makefile
index 9700962..b411849 100644
--- a/usr.sbin/amd/Makefile
+++ b/usr.sbin/amd/Makefile
@@ -3,10 +3,9 @@
 # Makefile for amd
 # 	This file is under a "BSD" copyright (c) by David O'Brien 1998
 #
-# $FreeBSD: src/usr.sbin/amd/Makefile,v 1.6.2.1 2001/04/25 12:09:12 ru Exp $
-# $DragonFly: src/usr.sbin/amd/Makefile,v 1.2 2003/06/17 04:29:52 dillon Exp $
-#
+# $FreeBSD: src/usr.sbin/amd/Makefile,v 1.9 2012/11/17 01:54:36 svnexp Exp $
 
-SUBDIR= include libamu amd amq doc fixmount fsinfo hlfsd mk-amd-map pawd scripts wire-test
+SUBDIR= include libamu amd amq doc fixmount fsinfo hlfsd mk-amd-map pawd \
+	scripts wire-test
 
 .include <bsd.subdir.mk>
diff --git a/usr.sbin/amd/Makefile.inc b/usr.sbin/amd/Makefile.inc
index add2c42..4b243fb 100644
--- a/usr.sbin/amd/Makefile.inc
+++ b/usr.sbin/amd/Makefile.inc
@@ -1,7 +1,6 @@
 # ex:ts=8
 #
-# $FreeBSD: src/usr.sbin/amd/Makefile.inc,v 1.5.2.1 2001/04/25 12:09:12 ru Exp $
-# $DragonFly: src/usr.sbin/amd/Makefile.inc,v 1.2 2003/06/17 04:29:52 dillon Exp $
+# $FreeBSD: src/usr.sbin/amd/Makefile.inc,v 1.18 2012/11/17 01:54:36 svnexp Exp $
 #
 # Makefile for amd
 # 	This file is under a "BSD" copyright (c) by David O'Brien 1998.
@@ -9,16 +8,24 @@
 #	$NetBSD: Makefile.inc,v 1.10 1998/08/08 22:33:27 christos Exp $
 #	Portions derived from amd/libamu/Makefile
 #	$NetBSD: Makefile,v 1.8 1998/08/08 22:33:37 christos Exp $
-#
 
-CFLAGS+=	-I. -I${.CURDIR} 
-CFLAGS+=	-I${.CURDIR}/../include
+.include <bsd.own.mk>
+
+CFLAGS+= -I. -I${.CURDIR} 
+CFLAGS+= -I${.CURDIR}/../include
 .if exists(${.OBJDIR}/../include)
-CFLAGS+=	-I${.OBJDIR}/../include
+CFLAGS+= -I${.OBJDIR}/../include
 .endif
-CFLAGS+=	-I${.CURDIR}/../../../contrib/amd/include
-CFLAGS+=	-I${.CURDIR}/../../../contrib/amd
-CFLAGS+=	-DHAVE_CONFIG_H
+CFLAGS+= -I${.CURDIR}/../../../contrib/amd/include
+CFLAGS+= -I${.CURDIR}/../../../contrib/amd
+CFLAGS+= -DHAVE_CONFIG_H
+CFLAGS+= -DHAVE_LOCALCONFIG_H
+
+.if defined(WANT_HESIOD)
+CFLAGS+= -DYES_HESIOD
+.endif
+
+CFLAGS+= -DHOST_CPU=\"${MACHINE_CPUARCH}\" -DHOST_ARCH=\"${MACHINE_ARCH}\"
 
 .if exists(${.OBJDIR}/../libamu)
 LIBAMUDIR=	${.OBJDIR}/../libamu
@@ -27,11 +34,11 @@ LIBAMUDIR=	${.CURDIR}/../libamu
 .endif
 LIBAMU=		${LIBAMUDIR}/libamu.a
 
-RPCCOM=		rpcgen
+RPCCOM=		RPCGEN_CPP=${CPP:Q} rpcgen
 MOUNT_X=	${DESTDIR}/usr/include/rpcsvc/mount.x
 NFS_PROT_X=	${DESTDIR}/usr/include/rpcsvc/nfs_prot.x
 
-WARNS?=		0
+WARNS?=	1
 
 .if exists(${.CURDIR}/../../Makefile.inc)
 .include "${.CURDIR}/../../Makefile.inc"
diff --git a/usr.sbin/amd/amd/Makefile b/usr.sbin/amd/amd/Makefile
index fec2910..6c05512 100644
--- a/usr.sbin/amd/amd/Makefile
+++ b/usr.sbin/amd/amd/Makefile
@@ -3,35 +3,36 @@
 # Makefile for amd
 # 	This file is under a "BSD" copyright (c) by David O'Brien 1998
 #
-# $FreeBSD: src/usr.sbin/amd/amd/Makefile,v 1.17.2.1 2001/04/25 12:09:12 ru Exp $
-# $DragonFly: src/usr.sbin/amd/amd/Makefile,v 1.4 2006/05/14 18:07:29 swildner Exp $
+# $FreeBSD: src/usr.sbin/amd/amd/Makefile,v 1.30 2012/11/17 01:54:36 svnexp Exp $
 #
 
-.PATH:		${.CURDIR}/../../../contrib/amd/amd
+.include <bsd.own.mk>
 
-PROG=		amd
-MAN=		amd.8
+.PATH: ${.CURDIR}/../../../contrib/amd/amd
 
-SRCS=		conf_parse.y conf_tok.l
-SRCS+=		am_ops.c amd.c amfs_auto.c amfs_direct.c amfs_error.c
-SRCS+=		amfs_host.c amfs_inherit.c amfs_link.c amfs_linkx.c amfs_nfsl.c
-SRCS+=		amfs_nfsx.c amfs_program.c amfs_root.c amfs_toplvl.c
-SRCS+=		amfs_union.c amq_subr.c amq_svc.c autil.c clock.c conf.c
-SRCS+=		get_args.c info_file.c info_ndbm.c info_nis.c info_passwd.c 
-SRCS+=		info_union.c map.c mapc.c mntfs.c nfs_prot_svc.c nfs_start.c 
-SRCS+=		nfs_subr.c ops_cdfs.c ops_lofs.c ops_mfs.c ops_nfs.c ops_nfs3.c 
-SRCS+=		ops_nullfs.c ops_pcfs.c ops_tfs.c ops_ufs.c
-SRCS+=		ops_unionfs.c opts.c restart.c rpc_fwd.c sched.c
-SRCS+=		srvr_amfs_auto.c srvr_nfs.c
+PROG=	amd
+MAN=	amd.8
+SRCS=	conf_parse.y conf_tok.l
+SRCS+=	am_ops.c amd.c amfs_auto.c amfs_direct.c amfs_error.c amfs_generic.c
+SRCS+=	amfs_host.c amfs_link.c amfs_linkx.c amfs_nfsl.c
+SRCS+=	amfs_nfsx.c amfs_program.c amfs_root.c amfs_toplvl.c
+SRCS+=	amfs_union.c amq_subr.c amq_svc.c autil.c clock.c conf.c
+SRCS+=	get_args.c info_exec.c info_file.c info_ndbm.c info_passwd.c
+SRCS+=	info_union.c map.c mapc.c mntfs.c nfs_prot_svc.c nfs_start.c
+SRCS+=	nfs_subr.c ops_cdfs.c ops_mfs.c ops_nfs.c ops_nfs3.c
+SRCS+=	ops_nullfs.c ops_pcfs.c ops_tfs.c ops_ufs.c ops_umapfs.c
+SRCS+=	ops_unionfs.c opts.c readdir.c restart.c rpc_fwd.c sched.c
+SRCS+=	srvr_amfs_auto.c srvr_nfs.c
 
-CFLAGS+=	-I${.CURDIR}/../../../contrib/amd/amd
+CFLAGS+= -I${.CURDIR}/../../../contrib/amd/amd \
+	 -I${DESTDIR}/usr/include/rpcsvc
 
-DPADD=		${LIBAMU} ${LIBRPCSVC}
-LDADD=		${LIBAMU} -lrpcsvc
+DPADD=	${LIBAMU} ${LIBWRAP}
+LDADD=	${LIBAMU} -lwrap
 
 CLEANFILES+=	conf_parse.c conf_parse.h conf_tok.c
 
-conf_tok.o:	conf_parse.h
+conf_tok.o: conf_parse.h
 
 #		These are generated at compile time
 SRCS+=		mount_xdr.c
@@ -40,4 +41,12 @@ CLEANFILES+=	mount_xdr.c
 mount_xdr.c: ${MOUNT_X}
 	${RPCCOM} -c -DWANT_NFS3 ${MOUNT_X} -o ${.TARGET}
 
+.if defined(WANT_HESIOD)
+SRCS+=	info_hesiod.c
+CFLAGS+= -DHAVE_MAP_HESIOD
+.endif
+
+SRCS+=	info_nis.c
+CFLAGS+= -DHAVE_MAP_NIS
+
 .include <bsd.prog.mk>
diff --git a/usr.sbin/amd/amq/Makefile b/usr.sbin/amd/amq/Makefile
index 8bf0651..8ab7c00 100644
--- a/usr.sbin/amd/amq/Makefile
+++ b/usr.sbin/amd/amq/Makefile
@@ -3,20 +3,18 @@
 # Makefile for amd
 # 	This file is under a "BSD" copyright (c) by David O'Brien 1998
 #
-# $FreeBSD: src/usr.sbin/amd/amq/Makefile,v 1.12.2.1 2001/04/25 12:09:13 ru Exp $
-# $DragonFly: src/usr.sbin/amd/amq/Makefile,v 1.2 2003/06/17 04:29:52 dillon Exp $
+# $FreeBSD: src/usr.sbin/amd/amq/Makefile,v 1.16 2012/11/17 01:54:36 svnexp Exp $
 #
 
-.PATH:		${.CURDIR}/../../../contrib/amd/amq
+.PATH: ${.CURDIR}/../../../contrib/amd/amq
 
-PROG=		amq
-MAN=		amq.8
+PROG=	amq
+MAN=	amq.8
+SRCS=	amq.c amq_clnt.c amq_xdr.c
 
-SRCS=		amq.c amq_clnt.c amq_xdr.c
+CFLAGS+= -I${.CURDIR}/../../../contrib/amd/amq
 
-CFLAGS+=	-I${.CURDIR}/../../../contrib/amd/amq
-
-DPADD+=		${LIBAMU}
-LDADD+=		${LIBAMU}
+DPADD=	${LIBAMU}
+LDADD=	${LIBAMU}
 
 .include <bsd.prog.mk>
diff --git a/usr.sbin/amd/doc/Makefile b/usr.sbin/amd/doc/Makefile
index a36fb61..78e68ab 100644
--- a/usr.sbin/amd/doc/Makefile
+++ b/usr.sbin/amd/doc/Makefile
@@ -1,7 +1,8 @@
 # 	This file is under a "BSD" copyright (c) by David O'Brien 1998.
 
-# $FreeBSD: src/usr.sbin/amd/doc/Makefile,v 1.10 1999/08/28 01:15:14 peter Exp $
-# $DragonFly: src/usr.sbin/amd/doc/Makefile,v 1.2 2003/06/17 04:29:52 dillon Exp $
+# $FreeBSD: src/usr.sbin/amd/doc/Makefile,v 1.12 2012/11/17 01:54:36 svnexp Exp $
+
+.PATH: ${.CURDIR}/../../../contrib/amd/doc
 
 INFO=	am-utils
 
@@ -10,6 +11,4 @@ INFOENTRY= 	"* Am-utils: (am-utils).	The Amd automounter suite of utilities"
 
 MAKEINFOFLAGS+=	-I ${.CURDIR}/../../../contrib/amd/doc
 
-.PATH:	${.CURDIR}/../../../contrib/amd/doc
-
 .include <bsd.info.mk>
